unit ufunktionen;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, Buttons, ExtCtrls;

type

  { Tf_funktionen }

  Tf_funktionen = class(TForm)
    BitBtn1: TBitBtn;
    b_ggT: TButton;
    b_summen: TButton;
    b_fakultaet: TButton;
    b_fibo: TButton;
    b_ampel: TButton;
    e_n: TEdit;
    e_m: TEdit;
    e_ggT: TEdit;
    e_summe: TEdit;
    e_fakult: TEdit;
    e_fibo: TEdit;
    e_ampel: TEdit;
    e_summe_aus: TEdit;
    e_fakult_aus: TEdit;
    e_fibo_aus: TEdit;
    e_ampel_aus: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    procedure b_ggTClick(Sender: TObject);
    procedure b_ampelClick(Sender: TObject);
    procedure b_fakultaetClick(Sender: TObject);
    procedure b_fiboClick(Sender: TObject);
    procedure b_summenClick(Sender: TObject);


  private
    { private declarations }
  public
    { public declarations }
  end;

var
  f_funktionen: Tf_funktionen;

implementation

{$R *.lfm}

{ Tf_funktionen }

procedure Tf_funktionen.b_summenClick(Sender: TObject);
VAR n, ps : LONGINT;

 FUNCTION Partialsumme(n : LONGINT):LONGINT;
 VAR s,i : LONGINT;
 BEGIN
  s:=0;
  FOR i:=1 TO n DO s := s + i;
  Partialsumme :=s;
 END;

begin
  //Wertuebergaben
  n := STRTOINT(e_summe.text);
  //Verarbeitung
  ps := Partialsumme(n);
  //Ausgabe
  e_summe_aus.text := INTTOSTR(ps);
end;


procedure Tf_funktionen.b_fakultaetClick(Sender: TObject);
VAR n, fak : INT64;

 FUNCTION nFakultaet(n : BYTE):INT64;
 VAR p: INT64; i:BYTE;
 BEGIN
  p:=1;
  FOR i:=1 TO n DO p := p * i;
  nFakultaet := p;
 END;

begin
 //Wertuebergaben
  n := STRTOINT(e_fakult.text);
  //Verarbeitung
  fak := nFakultaet(n);
  //Ausgabe
  e_fakult_aus.text := INTTOSTR(fak);
end;

procedure Tf_funktionen.b_ampelClick(Sender: TObject);
VAR f,fampel : STRING;

  FUNCTION Ereignis(Farbe : STRING) :STRING;
  BEGIN
   IF Farbe='rot'  THEN Ereignis := 'Halt!';
   IF Farbe='gelb'  THEN Ereignis := 'Kreuzung räumen!';
   IF Farbe='grün'  THEN Ereignis := 'Freie Fahrt!';
  END;

begin
 //Wertuebergaben
 f := e_ampel.text;
 //Verarbeitung
 fampel := Ereignis(f);
 //Ausgabe
 e_ampel_aus.text := fampel;
end;

procedure Tf_funktionen.b_ggTClick(Sender: TObject);
VAR ggTeiler,m,n : WORD;

  FUNCTION ggT(a,b : WORD):WORD;
  VAR h : WORD;
  BEGIN
   WHILE b <> 0 DO
    BEGIN
     h := a MOD b;
     a := b;
     b := h;
    END;
   ggT := a;
  END;

begin
 //Wertuebergaben
 m := STRTOINT(e_m.text);
 n := STRTOINT(e_n.text);
 //Verarbeitung
 IF m>n THEN ggTeiler := ggT(m,n)
        ELSE ggTeiler := ggT(n,m); //Wozu diese Zeile?
 ggTeiler := ggT(m,n);
 //Ausgabe
 e_ggT.text := INTTOSTR(ggTeiler);
end;

procedure Tf_funktionen.b_fiboClick(Sender: TObject);
VAR fibo , n : INTEGER;

 FUNCTION Fibonacci(n : INTEGER) : INTEGER;
 VAR m1, m2, summe, i : INTEGER;
 BEGIN
  m1:=0;
  m2:=1;
  summe:=0;
  FOR i:=1 TO n DO
   BEGIN
    summe:= m1+m2;
    m1 := m2;
    m2 := summe;
   END;
  Fibonacci := summe;
 END;

begin
 //Wertuebergaben
 n := STRTOINT(e_fibo.text);
 //Verarbeitung
 fibo := Fibonacci(n);
 //Ausgabe
 e_fibo_aus.text := INTTOSTR(fibo);
end;

end.

